#include <cstdio>
#include <stdlib.h>
using namespace std;

struct Pkt
{
	int x, y;
};

typedef Pkt T;

Pkt p;
int naj = 0;

bool operator< (const T A, const T B) {
	
	int distA = ( A.x - p.x ) * ( A.x - p.x ) + ( A.y - p.y) * (A.y - p.y);
	int distB = ( B.x - p.x ) * ( A.x - p.x ) + ( B.y - p.y) * (B.y - p.y);
	
	if(distA < distB)
		return true;
	
	return false;
}

inline int qcompare(T* A, T* B)
{
	return (*A) < (*B) ? -1 : 1;
}

int main()
{
	int N = 0, R = 0;
	int R2 = 0;
	Pkt buf[2000];
	
	for(;;)
	{
		naj = 0;
		scanf("%d %d", &N, &R);
		if(N == 0 && R == 0)
			break;
		
		for(int i =0 ; i < N; ++i)
		{
			scanf("%d %d", &buf[i].x, &buf[i].y);
		}
		
		R2 = R * R;
		
		for(int i = 0; i < N-1; ++i)
		{
			p = buf[i];
			int lok = 0;
			
			qsort(&buf[i+1], N-i,sizeof(Pkt),
					(int (*)(const void*, const void*))qcompare);
			
			float avg_x = p.x;
			float avg_y = p.y;
			int spr = 1;
			
			for(int j = i+1; j < N; j++)
			{
				float n = (float)(spr)/(float)(spr+1);
				float m = 1.0f / (float)(spr+1);
				
				avg_x = avg_x * n + (float)buf[j].x * m;
				avg_y = avg_y * n + (float)buf[j].y * m;
				spr++;
				
				int lok2 = 0;
				for(int k = i; k <= j; k++) {
					float distA = ( buf[k].x - avg_x ) * ( buf[k].x - avg_x ) + ( buf[k].y - avg_y) * (buf[k].y - avg_y);
					
					if(distA < (float)R2 + 0.001f)
						lok2++;
					else
					{
						if(naj < lok)
							naj = lok;
						
						break;
					}
				}
				
				if(lok2 == j-i+1)
					lok++;
			}
			
		}
		
		printf("It is possible to cover %d points.\n", naj);
	}
	
	return 0;
}
